//Variáveis de entrada e saída **********************************************************************
//Essas vaiáreis são utilizadas no loop *************************************************************
int PID_Turn_On = 0;                          //Variável para ligar ou desligar o controle PID
double PID_Setpoint = 0;                      //Valor do setpoint desejado
double PID_Input = 0;                         //Valor atual da entrada de controle
double PID_Output = 0;                        //Valor da saída de controle do PID
//Variáveis de setup*********************************************************************************
//Essas variáveis podem ou não serem alteradas no loop **********************************************
double PID_Output_Max = 3722;                 //Valor máximo da saída de controle
double PID_Output_Min = 0;                    //Valor mínimo da saída de controle
double PID_Kp = 10.0;                         //Valor do fator proporcional do controle (KP)
double PID_Ki = 1.0;                          //Valor do fator integral do controle (KI)
double PID_Kd = 0.1;                          //Valor do fator derivativo do controle (KD)
unsigned long PID_SampleTime = 1000;          //Tempo de ciclo de cálculo do controle em ms
//Variáveis de controle******************************************************************************
double PID_LastInput = 0;                     //Variável para cálculo do delta de variação
double PID_Ki_Compute = 0;                    //Variável para armazenar o cálculo interno do valor integral
unsigned long PID_LastTime = 0;               //Variável para cálculo do tempo de ciclo
double PID_Error = 0;                         //Variável que recebe o cálculo do erro do controle

//Função de controle ********************************************************************************
void PID_Ctrl(){

  //Controle PID desligado
  if (PID_Turn_On == 0){
    PID_LastInput = PID_Input;
    PID_Output = 0;
    PID_Ki_Compute = 0;
    PID_LastTime = millis();
    PID_Error = 0;
  }else{
  //Controle PID Ligado
    if (millis() >= (PID_LastTime + PID_SampleTime)){
      PID_Error = PID_Setpoint - PID_Input;
      if ((PID_Ki_Compute <= PID_Output_Max) && (PID_Ki_Compute >= PID_Output_Min)){
        PID_Ki_Compute += (PID_Ki * PID_Error);
      }
      if (PID_Ki_Compute >= PID_Output_Max){
        PID_Ki_Compute = PID_Output_Max;
      }else if (PID_Ki_Compute <= PID_Output_Min){
        PID_Ki_Compute = PID_Output_Min;
      }
      PID_Output = (PID_Kp * PID_Error) + PID_Ki_Compute - (PID_Kd * (PID_Input - PID_LastInput));
      PID_LastTime = millis();
      PID_LastInput = PID_Input;
      if (PID_Output >= PID_Output_Max){
        PID_Output = PID_Output_Max;
      }else if (PID_Output <= PID_Output_Min){
        PID_Output = PID_Output_Min;
      } 
    }
  } 
}
