//Exemplo para implementação de um controle PID

//Definição dos pinos analógicos
#define pin_AI1 35
#define pin_AO1 32

//Definição das variáveis do software
double PAR_Setpoint = 55.1        //Setpoint para controle (%)

void setup() {
  
  //Configuração das comunicações
  Serial.begin(115200);//USB

  //Configuração função PWM para a sída analógica
  //(canal, frequência, resolução)
  ledcSetup(0, 1000, 12);
  //(pino de controle, canal)
  ledcAttachPin(pin_AO1, 0);

}

void loop() {
  
  //Atribuição do setpoint de controle
  PID_Setpoint = PAR_Setpoint;
  //Leitura da entrada de controle
  PID_Input = map(analogRead(pin_AI1), 0, 3649, 0, 100);
  //Escrita da saída de controle
  ledcWrite(0, PID_Output);

  //Visualização dos valores
  Serial.print("Setpoint : ");
  Serial.println(PAR_Setpoint);
  Serial.print("Input : ");
  Serial.println(PID_Input);
  Serial.print("Output %/Un : ");
  Serial.print(((3722 - PID_Output)*100)/PID_Output);
  Serial.print(" / ");
  Serial.println(PID_Output);
  
}
